using System;
using System.Collections;
using System.Drawing;
using System.Reflection;
using System.Windows.Forms;

using Syncfusion.Windows.Forms.Grid.Grouping;

namespace Citi.CurveBuilder
{
	/// <summary>
	/// Summary description for BlinkingCellHelper.
	/// </summary>
	public class BlinkingCellHelper
	{
		
		private ArrayList _blinkingCellList;
		private System.Windows.Forms.Timer _mktRateTimer;
		private GridTableCellStyleInfoEventArgs _e;
		private int _noOfIterations;

		private GridGroupingControl _dataGrid;


		public BlinkingCellHelper(GridTableCellStyleInfoEventArgs e_, int interval_, int noOfIterations_, GridGroupingControl dataGrid_)//, Citi.CurveBuilder.SwapDataGridListener.Cell currentCell_, 
		{	
			_e = e_;
			_blinkingCellList = new ArrayList();
			_dataGrid = dataGrid_;
			/// Works if change backgroudn color here
			//_e.Style.BackColor = Color.Red;
			_noOfIterations = noOfIterations_;
			_mktRateTimer = new System.Windows.Forms.Timer();
			// Below is for 200ms.  Change this to be a Global Property
			_mktRateTimer.Interval = interval_;
			_mktRateTimer.Tick += new EventHandler(_mktRateTimer_Tick);
			_mktRateTimer.Start();
		}

		
		private void _mktRateTimer_Tick(object sender, EventArgs e)
		{
			if(_noOfIterations > 0)
			{
				// Initially tried setting directly here but this didn't work
				///_e.Style.BackColor = Color.Red;
				/// Tried doing this via the GridGroupingControl as I thought it might be necessary to
				/// hand back to the single thread GUI uses but this still doesn't work.
				MethodInvoker mi = new MethodInvoker(refresh);
				_dataGrid.BeginInvoke(mi);
			}
			else 
			{
				_mktRateTimer.Stop();
			}
			_noOfIterations--;
		}

		protected void refresh()
		{
			lock (this) 
			{
				// The below has no impact
				_e.Style.BackColor = Color.Red;
			}
		}

	}
}
